----------------------------------------------------------------
-- Copyright (c) 2010-2011 Zipline Games, Inc. 
-- All Rights Reserved. 
-- http://getmoai.com
----------------------------------------------------------------

MOAISim.openWindow ( "test", 544, 272 )

viewport = MOAIViewport.new ()
viewport:setSize ( 544, 272 )
viewport:setScale ( 544, 272 )

layer = MOAILayer2D.new ()
layer:setViewport ( viewport )
MOAISim.pushRenderPass ( layer )

grid = MOAIGrid.new ()
grid:initDiamondGrid ( 8, 16, 64, 32 )

grid:setRow ( 1, 	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x00, 0x03 )
grid:setRow ( 2,	0x03, 0x03, 0x03, 0x03, 0x03, 0x00, 0x03, 0x03 )
grid:setRow ( 3,	0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03 )
grid:setRow ( 4,	0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03, 0x03 )
grid:setRow ( 5,	0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03, 0x03 )
grid:setRow ( 6,	0x00, 0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03 )
grid:setRow ( 7,	0x00, 0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03 )
grid:setRow ( 8,	0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03 )
grid:setRow ( 9,	0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03 )
grid:setRow ( 10,	0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03, 0x00 )
grid:setRow ( 11,	0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03, 0x00 )
grid:setRow ( 12,	0x03, 0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03 )
grid:setRow ( 13,	0x03, 0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03 )
grid:setRow ( 14,	0x03, 0x03, 0x00, 0x03, 0x03, 0x00, 0x03, 0x03 )
grid:setRow ( 15,	0x03, 0x03, 0x00, 0x03, 0x03, 0x03, 0x03, 0x03 )
grid:setRow ( 16,	0x03, 0x00, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03 )

tileDeck = MOAITileDeck2D.new ()
tileDeck:setTexture ( "diamond-tiles.png" )
tileDeck:setSize ( 4, 4 )

prop = MOAIProp2D.new ()
prop:setDeck ( tileDeck )
prop:setGrid ( grid )
prop:setLoc ( -272, -128 )
layer:insertProp ( prop )

startNode = grid:getCellAddr ( 1, 1 )
endNode = grid:getCellAddr ( 8, 16 )

pathFinder = MOAIPathFinder.new ()
pathFinder:setGraph ( grid )
pathFinder:setHeuristic ( MOAIGridPathGraph.EUCLIDEAN_DISTANCE )
pathFinder:init ( startNode, endNode )

while pathFinder:findPath ( 3 ) do
	print ( 'finding...' )
end

pathSize = pathFinder:getPathSize ()
for i = 1, pathSize do
	entry = pathFinder:getPathEntry ( i )
	x, y = grid:cellAddrToCoord ( entry )
	grid:setTile ( x, y, 0x02 )
end

grid:setTile ( 1, 1, 0x01 )
grid:setTile ( 8, 16, 0x04 )